diff -pruN 2.0.7-2/.github/workflows/pypi.yaml 2.0.8-1/.github/workflows/pypi.yaml
--- 2.0.7-2/.github/workflows/pypi.yaml	2022-09-16 18:41:41.000000000 +0000
+++ 2.0.8-1/.github/workflows/pypi.yaml	2024-04-24 18:59:53.000000000 +0000
@@ -11,10 +11,10 @@ jobs:
     steps:
       - uses: actions/checkout@v2
       - run: python -m pip install --upgrade pip
-      - run: python -m pip install flake8 pytest
+      - run: python -m pip install flake8 pytest build
       - run: python -m pytest -v
       - run: flake8 .
-      - run: python setup.py sdist
+      - run: python -m build --sdist
       - uses: pypa/gh-action-pypi-publish@release/v1
         with:
           user: __token__
diff -pruN 2.0.7-2/.github/workflows/pytest.yaml 2.0.8-1/.github/workflows/pytest.yaml
--- 2.0.7-2/.github/workflows/pytest.yaml	2022-09-16 18:41:41.000000000 +0000
+++ 2.0.8-1/.github/workflows/pytest.yaml	2024-04-24 18:59:53.000000000 +0000
@@ -14,15 +14,19 @@ jobs:
       fail-fast: false
       matrix:
         python-version:
-          - 3.3
-          - 3.4
-          - 3.5
-          - 3.6
-          - 3.7
-          - 3.8
-          - 3.9
+          - '3.8'
+          - '3.9'
+          - '3.10'
+          - '3.11'
+          - '3.12'
     steps:
-      - uses: actions/checkout@v2
+      - uses: actions/checkout@v4
+      - name: Set up Python ${{ matrix.python-version }}
+        uses: actions/setup-python@v4
+        with:
+          python-version: ${{ matrix.python-version }}
+      - name: Display Python version
+        run: python -c "import sys; print(sys.version)"
       - run: python -m pip install --upgrade pip
       - run: python -m pip install flake8 pytest
       - run: python -m pytest -v
diff -pruN 2.0.7-2/LICENSE 2.0.8-1/LICENSE
--- 2.0.7-2/LICENSE	2022-09-16 18:41:41.000000000 +0000
+++ 2.0.8-1/LICENSE	2024-04-24 18:59:53.000000000 +0000
@@ -4,7 +4,7 @@
 #    |_|_|_|_|_||_|_\__,_|_.__/
 #    simple python object store
 #
-# Copyright 2009-2010, 2014-2017 Thomas Perl <thp.io>. All rights reserved.
+# Copyright 2009-2010, 2014-2022, 2024 Thomas Perl <thp.io>. All rights reserved.
 #
 # Permission to use, copy, modify, and/or distribute this software for any
 # purpose with or without fee is hereby granted, provided that the above
diff -pruN 2.0.7-2/debian/changelog 2.0.8-1/debian/changelog
--- 2.0.7-2/debian/changelog	2024-03-11 21:39:04.000000000 +0000
+++ 2.0.8-1/debian/changelog	2024-04-25 19:32:11.000000000 +0000
@@ -1,3 +1,14 @@
+minidb (2.0.8-1) unstable; urgency=medium
+
+  [ Maxime Werlen ]
+  * New upstream release
+  * Remove patch now included upstream
+
+  [ Jeroen Ploemen ]
+  * Copyright: bump upstream years.
+
+ -- Maxime Werlen <maxime@werlen.fr>  Thu, 25 Apr 2024 21:32:11 +0200
+
 minidb (2.0.7-2) unstable; urgency=medium
 
   * Add a patch to switch from distutils to setuptools (closes: #1065902)
diff -pruN 2.0.7-2/debian/copyright 2.0.8-1/debian/copyright
--- 2.0.7-2/debian/copyright	2024-03-11 21:39:04.000000000 +0000
+++ 2.0.8-1/debian/copyright	2024-04-25 19:32:11.000000000 +0000
@@ -4,7 +4,7 @@ Upstream-Contact: Thomas Perl <thp.io>
 Source: https://thp.io/2010/minidb/
 
 Files: *
-Copyright: 2009-2010,2014-2022 Thomas Perl <thp.io>
+Copyright: 2009-2010, 2014-2022, 2024 Thomas Perl <thp.io>
 License: ISC
 
 Files: debian/*
diff -pruN 2.0.7-2/debian/patches/series 2.0.8-1/debian/patches/series
--- 2.0.7-2/debian/patches/series	2024-03-11 21:39:04.000000000 +0000
+++ 2.0.8-1/debian/patches/series	2024-04-25 19:32:11.000000000 +0000
@@ -1,2 +1 @@
 clean_readme.diff
-setuptools.diff
diff -pruN 2.0.7-2/debian/patches/setuptools.diff 2.0.8-1/debian/patches/setuptools.diff
--- 2.0.7-2/debian/patches/setuptools.diff	2024-03-11 21:39:04.000000000 +0000
+++ 2.0.8-1/debian/patches/setuptools.diff	1970-01-01 00:00:00.000000000 +0000
@@ -1,18 +0,0 @@
-Description: Replace distutils by setuptools
-Author: Maxime Werlen <maxime@werlen.fr>
-Bug-Debian: http://bugs.debian.org/1065902
-Forwarded: https://github.com/thp/minidb/pull/20
-Last-Update: 2024-03-11
----
-This patch header follows DEP-3: http://dep.debian.net/deps/dep3/
---- a/setup.py
-+++ b/setup.py
-@@ -5,7 +5,7 @@
- 
- import os
- import re
--from distutils.core import setup
-+from setuptools import setup
- 
- dirname = os.path.dirname(os.path.abspath(__file__))
- src = open(os.path.join(dirname, '{}.py'.format(__doc__))).read()
diff -pruN 2.0.7-2/minidb.py 2.0.8-1/minidb.py
--- 2.0.7-2/minidb.py	2022-09-16 18:41:41.000000000 +0000
+++ 2.0.8-1/minidb.py	2024-04-24 18:59:53.000000000 +0000
@@ -5,7 +5,7 @@
 #    |_|_|_|_|_||_|_\__,_|_.__/
 #    simple python object store
 #
-# Copyright 2009-2010, 2014-2022 Thomas Perl <thp.io>. All rights reserved.
+# Copyright 2009-2010, 2014-2022, 2024 Thomas Perl <thp.io>. All rights reserved.
 #
 # Permission to use, copy, modify, and/or distribute this software for any
 # purpose with or without fee is hereby granted, provided that the above
@@ -36,7 +36,7 @@ import logging
 
 
 __author__ = 'Thomas Perl <m@thp.io>'
-__version__ = '2.0.7'
+__version__ = '2.0.8'
 __url__ = 'http://thp.io/2010/minidb/'
 __license__ = 'ISC'
 
@@ -412,7 +412,7 @@ class Store(object):
                     type_ = attr_to_type.get(name, None)
                     yield (self.deserialize(value, type_) if type_ is not None else value)
 
-            return (RowProxy(tuple(_decode(row, columns)), columns) for row in result)
+            return (RowProxy(tuple(_decode(row, columns)), columns) for row in list(result))
 
     def load(self, class_, *args, **kwargs):
         with self.lock:
diff -pruN 2.0.7-2/setup.py 2.0.8-1/setup.py
--- 2.0.7-2/setup.py	2022-09-16 18:41:41.000000000 +0000
+++ 2.0.8-1/setup.py	2024-04-24 18:59:53.000000000 +0000
@@ -5,7 +5,7 @@
 
 import os
 import re
-from distutils.core import setup
+from setuptools import setup
 
 dirname = os.path.dirname(os.path.abspath(__file__))
 src = open(os.path.join(dirname, '{}.py'.format(__doc__))).read()
diff -pruN 2.0.7-2/test/test_minidb.py 2.0.8-1/test/test_minidb.py
--- 2.0.7-2/test/test_minidb.py	2022-09-16 18:41:41.000000000 +0000
+++ 2.0.8-1/test/test_minidb.py	2024-04-24 18:59:53.000000000 +0000
@@ -1,3 +1,4 @@
+import concurrent.futures
 import minidb
 import pytest
 import datetime
@@ -264,10 +265,10 @@ def test_storing_and_retrieving_floats()
         db.register(FloatModel)
         float_id = FloatModel(value=3.1415).save(db).id
         get_value = FloatModel.get(db, id=float_id).value
-        assert type(get_value) == float
+        assert isinstance(get_value, float)
         assert get_value == 3.1415
         query_value = next(FloatModel.c.value.query(db, where=lambda c: c.id == float_id)).value
-        assert type(query_value) == float
+        assert isinstance(query_value, float)
         assert query_value == 3.1415
 
 
@@ -284,10 +285,10 @@ def test_storing_and_retrieving_bytes():
         db.register(BytesModel)
         bytes_id = BytesModel(value=BLOB).save(db).id
         get_value = BytesModel.get(db, id=bytes_id).value
-        assert type(get_value) == bytes
+        assert isinstance(get_value, bytes)
         assert get_value == BLOB
         query_value = next(BytesModel.c.value.query(db, where=lambda c: c.id == bytes_id)).value
-        assert type(query_value) == bytes
+        assert isinstance(query_value, bytes)
         assert query_value == BLOB
 
 
@@ -590,19 +591,19 @@ def test_storing_and_retrieving_datetime
         db.register(DateTimeModel)
         datetime_id = DateTimeModel(dt=DT_NOW, da=D_TODAY, tm=T_NOW).save(db).id
         get_value = DateTimeModel.get(db, id=datetime_id)
-        assert type(get_value.dt) == datetime.datetime
+        assert isinstance(get_value.dt, datetime.datetime)
         assert get_value.dt == DT_NOW
-        assert type(get_value.da) == datetime.date
+        assert isinstance(get_value.da, datetime.date)
         assert get_value.da == D_TODAY
-        assert type(get_value.tm) == datetime.time
+        assert isinstance(get_value.tm, datetime.time)
         assert get_value.tm == T_NOW
         query_value = next(DateTimeModel.query(db, lambda c: c.dt // c.da // c.tm,
                                                where=lambda c: c.id == datetime_id))
-        assert type(query_value.dt) == datetime.datetime
+        assert isinstance(query_value.dt, datetime.datetime)
         assert query_value.dt == DT_NOW
-        assert type(query_value.da) == datetime.date
+        assert isinstance(query_value.da, datetime.date)
         assert query_value.da == D_TODAY
-        assert type(query_value.tm) == datetime.time
+        assert isinstance(query_value.tm, datetime.time)
         assert query_value.tm == T_NOW
 
 
@@ -640,11 +641,11 @@ def test_custom_converter():
         p = Point(1.12, 5.99)
         player_id = Player(name='Foo', position=p).save(db).id
         get_value = Player.get(db, id=player_id)
-        assert type(get_value.position) == Point
+        assert isinstance(get_value.position, Point)
         assert (get_value.position.x, get_value.position.y) == (p.x, p.y)
         query_value = next(Player.query(db, lambda c: c.position,
                                         where=lambda c: c.id == player_id))
-        assert type(query_value.position) == Point
+        assert isinstance(query_value.position, Point)
         assert (query_value.position.x, query_value.position.y) == (p.x, p.y)
 
 
@@ -662,3 +663,30 @@ def test_delete_all():
 
         db.delete_all(Thing)
         assert db.count_rows(Thing) == 0
+
+
+def test_threaded_query():
+    class Thing(minidb.Model):
+        s = str
+        i = int
+
+    with minidb.Store(debug=True, vacuum_on_close=False) as db:
+        db.register(Thing)
+
+        for i in range(100):
+            db.save(Thing(s=str(i), i=i))
+
+        def query(i):
+            things = list(Thing.query(db, Thing.c.s // Thing.c.i, where=Thing.c.i == i))
+            assert len(things) == 1
+
+            thing = things[0]
+            assert thing is not None
+            assert thing.s == str(i)
+            assert thing.i == i
+
+            return i
+
+        executor = concurrent.futures.ThreadPoolExecutor(max_workers=10)
+        # Wrap in list to resolve all the futures
+        list(executor.map(query, range(100)))
